<?php
/**
 * Pocket Project
 * 
 * @copyright 2006 Power-Station co., Ltd, ALL Rights Reserved,
 */

/**
 *  BBS設定情報の取得
 *
 *  @access public
 */
function db_get_bbs_config_all()
{
    $sql = 'SELECT name, value' .
            ' FROM pbb_bbs_config';
    return pocket_db_getAll($sql);
}

/**
 *  指定名称のBBS設定値の取得
 *
 *  @access public
 *  @param  string  $name               設定名称
 */
function db_get_bbs_config_value($name)
{
    $sql = 'SELECT value' .
            ' FROM pbb_bbs_config' .
            ' WHERE name = ?';
    $params = array(
        $name
    );
    return pocket_db_getOne($sql, $params);
}

/**
 *  BBS設定情報の登録
 *
 *  @access public
 *  @param  string  $name               設定名称
 *  @param  string  $value              設定値
 */
function db_insert_bbs_config($name, $value)
{
    $data = array(
        'name' => $name,
        'value' => $value
    );
    return pocket_db_insert('pbb_bbs_config', $data, 'pbb_bbs_config_bbs_config_id_seq');
}

/**
 *  BBS設定情報の更新
 *
 *  @access public
 *  @param  string  $name               設定名称
 *  @param  string  $value              設定値
 */
function db_update_bbs_config($name, $value)
{
    $data = array(
        'value' => $value
    );
    $where = array(
        'name' => $name
    );
    return pocket_db_update('pbb_bbs_config', $data, $where);
}

?>
